// Image.h : interface of the CImage class
//
/////////////////////////////////////////////////////////////////////////////
#ifndef _IMAGE
#define _IMAGE

//	Image constants 

#ifndef SUCCESS 
#define SUCCESS		0
#endif

#ifndef FAILURE
#define FAILURE		-1
#endif

// Forward declaration for the class CImageImp
class CImageImp;

// Class declaration
class CImage
{
	// Constructor and Destructor
	public :
		CImage();
		virtual ~CImage();

	// Services
	public :
		virtual INT Load( LPCSTR, CRuntimeClass * )	= 0;
		virtual INT	Show( CWnd *, WPARAM );
		INT			GetImageWidth();
		INT			GetImageHeight();

	// Attributes
	protected :
		CImageImp	* m_pImageImp;
};

// Class declaration
class CBmpImage : public CImage
{
	// Constructor and Destructor
	public :
		CBmpImage();
		virtual ~CBmpImage();

	// Services
	public :
		virtual INT	Load( LPCSTR, CRuntimeClass * );

	// Implementaion
	protected :
		INT	ReadColorEntries( INT, CFile *, BOOL, CImageImp * );
};
#endif
