// ImageImp.h : interface of the CImageImp class
//
/////////////////////////////////////////////////////////////////////////////

#ifndef IMAGE_IMP
#define IMAGE_IMP

//	Predefined constants 
#ifndef SUCCESS 
#define SUCCESS		0
#endif

#ifndef FAILURE
#define FAILURE		-1
#endif

class CImageImp : public CObject
{
	// Constructor / Destructor
	public :
		CImageImp();
		virtual ~CImageImp();

	// List of Services to be defined by the derived class
	public :
		virtual INT		InitImageInfo( LPSTR )					= 0;
		virtual INT		GetNumColors( LPSTR = NULL )			= 0;
		virtual LPSTR	GetColorTable()							= 0;
		virtual BOOL	PaintImage( CWnd *, CRect * )			= 0;
		virtual BOOL	CreateImagePalette()						= 0;
		DECLARE_DYNAMIC( CImageImp )

	// Attributes
	public :
		LPBYTE				m_pImage;
		LONG					m_lNormalWidth;
		LONG					m_lNormalHeight;
};

// CWinImp class declaration
class CWinImp : public CImageImp
{
	// Constructor / Destructor
	public :
		CWinImp();
		virtual ~CWinImp();

	// Services to be defined by this class
	public :
		INT		InitImageInfo( LPSTR );
		INT		GetNumColors( LPSTR = NULL );
		LPSTR		GetColorTable();
		BOOL		PaintImage( CWnd *, CRect * );
		BOOL		CreateImagePalette();
		DECLARE_DYNCREATE( CWinImp )

	// Attributes
	protected :
		BYTE					* m_pBmi;
		CPalette				* m_pPalette;
};
#endif